/*
 * Copyright 2003-2006 Stream Converter Project Team.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, 
 * either express or implied. See the License for the specific language
 * governing permissions and limitations under the License.
 */
package jp.sf.stconv.pipeline.valve;

import jp.sf.stconv.pipeline.PipelineException;
import jp.sf.stconv.storage.StreamStorage;

public interface Valve {
    public void invoke(StreamStorage storage, ValveContext context)
            throws PipelineException;

    /**
     * Initialize the valve before using in a pipeline.
     */
    public void initialize() throws PipelineException;

}
